Package org.mariadb.jdbc

# Class DatabaseMetaData

java.lang.Object
org.mariadb.jdbc.DatabaseMetaData

All Implemented Interfaces:
  `DatabaseMetaData`, `Wrapper`

public class DatabaseMetaData extends Object implements DatabaseMetaData
Mariadb Database metadata

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DRIVER_NAME`
MariaDB driver name

### Fields inherited from interface java.sql.DatabaseMetaData

`attributeNoNulls, attributeNullable, attributeNullableUnknown, bestRowNotPseudo, bestRowPseudo, bestRowSession, bestRowTemporary, bestRowTransaction, bestRowUnknown, columnNoNulls, columnNullable, columnNullableUnknown, functionColumnIn, functionColumnInOut, functionColumnOut, functionColumnResult, functionColumnUnknown, functionNoNulls, functionNoTable, functionNullable, functionNullableUnknown, functionResultUnknown, functionReturn, functionReturnsTable, importedKeyCascade, importedKeyInitiallyDeferred, importedKeyInitiallyImmediate, importedKeyNoAction, importedKeyNotDeferrable, importedKeyRestrict, importedKeySetDefault, importedKeySetNull, procedureColumnIn, procedureColumnInOut, procedureColumnOut, procedureColumnResult, procedureColumnReturn, procedureColumnUnknown, procedureNoNulls, procedureNoResult, procedureNullable, procedureNullableUnknown, procedureResultUnknown, procedureReturnsResult, sqlStateSQL, sqlStateSQL99, sqlStateXOpen, tableIndexClustered, tableIndexHashed, tableIndexOther, tableIndexStatistic, typeNoNulls, typeNullable, typeNullableUnknown, typePredBasic, typePredChar, typePredNone, typeSearchable, versionColumnNotPseudo, versionColumnPseudo, versionColumnUnknown`

## Constructor Summary

Constructors
Constructor
Description
`DatabaseMetaData(Connection connection, Configuration conf)`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allProceduresAreCallable()`
`boolean`
`allTablesAreSelectable()`
`boolean`
`autoCommitFailureClosesAllResultSets()`
`boolean`
`dataDefinitionCausesTransactionCommit()`
`boolean`
`dataDefinitionIgnoredInTransactions()`
`boolean`
`deletesAreDetected(int type)`
`boolean`
`doesMaxRowSizeIncludeBlobs()`
`static String`
`escapeString(String value, boolean noBackslashEscapes)`
Escape String.
`boolean`
`generatedKeyAlwaysReturned()`
`ResultSet`
`getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern)`
Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog.
`ResultSet`
`getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable)`
Retrieves a description of a table's optimal set of columns that uniquely identifies a row.
`ResultSet`
`getCatalogs()`
`String`
`getCatalogSeparator()`
`String`
`getCatalogTerm()`
`ResultSet`
`getClientInfoProperties()`
Retrieves a list of the client info properties that the driver supports.
`ResultSet`
`getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern)`
Retrieves a description of the access rights for a table's columns.
`ResultSet`
`getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)`
Retrieves a description of table columns available in the specified catalog.
`Connection`
`getConnection()`
`ResultSet`
`getCrossReference(String parentCatalog, String parentSchema, String parentTable, String foreignCatalog, String foreignSchema, String foreignTable)`
Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key or the columns representing a unique constraint of the parent table (could be the same or a different table).
`int`
`getDatabaseMajorVersion()`
`int`
`getDatabaseMinorVersion()`
`String`
`getDatabaseProductName()`
Return Server type.
`String`
`getDatabaseProductVersion()`
`int`
`getDefaultTransactionIsolation()`
`int`
`getDriverMajorVersion()`
`int`
`getDriverMinorVersion()`
`String`
`getDriverName()`
`String`
`getDriverVersion()`
`ResultSet`
`getExportedKeys(String catalog, String schema, String table)`
Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table).
`String`
`getExtraNameCharacters()`
`ResultSet`
`getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern)`
Retrieves a description of the given catalog's system or user function parameters and return type.
`ResultSet`
`getFunctions(String catalog, String schemaPattern, String functionNamePattern)`
Retrieves a description of the system and user functions available in the given catalog.
`String`
`getIdentifierQuoteString()`
`ResultSet`
`getImportedKeys(String catalog, String schema, String table)`
Retrieves a description of the primary key columns that are referenced by the given table's foreign key columns (the primary keys imported by a table).
`ResultSet`
`getImportedKeysUsingInformationSchema(String database, String table)`
GetImportedKeysUsingInformationSchema.
`ResultSet`
`getImportedKeysUsingShowCreateTable(String database, String table)`
GetImportedKeysUsingShowCreateTable.
`ResultSet`
`getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate)`
Retrieves a description of the given table's indices and statistics.
`int`
`getJDBCMajorVersion()`
`int`
`getJDBCMinorVersion()`
`int`
`getMaxBinaryLiteralLength()`
`int`
`getMaxCatalogNameLength()`
`int`
`getMaxCharLiteralLength()`
`int`
`getMaxColumnNameLength()`
`int`
`getMaxColumnsInGroupBy()`
`int`
`getMaxColumnsInIndex()`
`int`
`getMaxColumnsInOrderBy()`
`int`
`getMaxColumnsInSelect()`
`int`
`getMaxColumnsInTable()`
`int`
`getMaxConnections()`
`int`
`getMaxCursorNameLength()`
`int`
`getMaxIndexLength()`
`long`
`getMaxLogicalLobSize()`
`int`
`getMaxProcedureNameLength()`
`int`
`getMaxRowSize()`
`int`
`getMaxSchemaNameLength()`
`int`
`getMaxStatementLength()`
`int`
`getMaxStatements()`
`int`
`getMaxTableNameLength()`
`int`
`getMaxTablesInSelect()`
`int`
`getMaxUserNameLength()`
`String`
`getNumericFunctions()`
List of numeric functions.
`ResultSet`
`getPrimaryKeys(String catalog, String schema, String table)`
Retrieves a description of the given table's primary key columns.
`ResultSet`
`getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern)`
Retrieves a description of the given catalog's stored procedure parameter and result columns.
`ResultSet`
`getProcedures(String catalog, String schemaPattern, String procedureNamePattern)`
Retrieves a description of the stored procedures available in the given catalog.
`String`
`getProcedureTerm()`
`ResultSet`
`getPseudoColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern)`
Retrieves a description of the pseudo or hidden columns available in a given table within the specified catalog and schema.
`int`
`getResultSetHoldability()`
`RowIdLifetime`
`getRowIdLifetime()`
`ResultSet`
`getSchemas()`
`ResultSet`
`getSchemas(String catalog, String schemaPattern)`
`String`
`getSchemaTerm()`
`String`
`getSearchStringEscape()`
`String`
`getSQLKeywords()`
Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL:2003 keywords.
`int`
`getSQLStateType()`
`String`
`getStringFunctions()`
List of string functions.
`ResultSet`
`getSuperTables(String catalog, String schemaPattern, String tableNamePattern)`
Retrieves a description of the table hierarchies defined in a particular schema in this database.
`ResultSet`
`getSuperTypes(String catalog, String schemaPattern, String typeNamePattern)`
Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database.
`String`
`getSystemFunctions()`
List of system functions.
`ResultSet`
`getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern)`
Retrieves a description of the access rights for each table available in a catalog.
`ResultSet`
`getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types)`
Retrieves a description of the tables available in the given catalog.
`ResultSet`
`getTableTypes()`
`String`
`getTimeDateFunctions()`
List of time and date functions.
`ResultSet`
`getTypeInfo()`
Retrieves a description of all the data types supported by this database.
`ResultSet`
`getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types)`
Retrieves a description of the user-defined types (UDTs) defined in a particular schema.
`String`
`getURL()`
`String`
`getUserName()`
`ResultSet`
`getVersionColumns(String catalog, String schema, String table)`
Retrieves a description of a table's columns that are automatically updated when any value in a row is updated.
`boolean`
`insertsAreDetected(int type)`
`boolean`
`isCatalogAtStart()`
`boolean`
`isReadOnly()`
`boolean`
`isWrapperFor(Class<?> iface)`
`boolean`
`locatorsUpdateCopy()`
`boolean`
`nullPlusNonNullIsNull()`
`boolean`
`nullsAreSortedAtEnd()`
`boolean`
`nullsAreSortedAtStart()`
`boolean`
`nullsAreSortedHigh()`
`boolean`
`nullsAreSortedLow()`
`boolean`
`othersDeletesAreVisible(int type)`
`boolean`
`othersInsertsAreVisible(int type)`
`boolean`
`othersUpdatesAreVisible(int type)`
`boolean`
`ownDeletesAreVisible(int type)`
`boolean`
`ownInsertsAreVisible(int type)`
`boolean`
`ownUpdatesAreVisible(int type)`
`boolean`
`storesLowerCaseIdentifiers()`
`boolean`
`storesLowerCaseQuotedIdentifiers()`
`boolean`
`storesMixedCaseIdentifiers()`
`boolean`
`storesMixedCaseQuotedIdentifiers()`
`boolean`
`storesUpperCaseIdentifiers()`
`boolean`
`storesUpperCaseQuotedIdentifiers()`
`boolean`
`supportsAlterTableWithAddColumn()`
`boolean`
`supportsAlterTableWithDropColumn()`
`boolean`
`supportsANSI92EntryLevelSQL()`
`boolean`
`supportsANSI92FullSQL()`
`boolean`
`supportsANSI92IntermediateSQL()`
`boolean`
`supportsBatchUpdates()`
`boolean`
`supportsCatalogsInDataManipulation()`
`boolean`
`supportsCatalogsInIndexDefinitions()`
`boolean`
`supportsCatalogsInPrivilegeDefinitions()`
`boolean`
`supportsCatalogsInProcedureCalls()`
`boolean`
`supportsCatalogsInTableDefinitions()`
`boolean`
`supportsColumnAliasing()`
`boolean`
`supportsConvert()`
`boolean`
`supportsConvert(int fromType, int toType)`
Retrieves whether this database supports the JDBC scalar function CONVERT for conversions between the JDBC types fromType and toType.
`boolean`
`supportsCoreSQLGrammar()`
`boolean`
`supportsCorrelatedSubqueries()`
`boolean`
`supportsDataDefinitionAndDataManipulationTransactions()`
`boolean`
`supportsDataManipulationTransactionsOnly()`
`boolean`
`supportsDifferentTableCorrelationNames()`
`boolean`
`supportsExpressionsInOrderBy()`
`boolean`
`supportsExtendedSQLGrammar()`
`boolean`
`supportsFullOuterJoins()`
`boolean`
`supportsGetGeneratedKeys()`
`boolean`
`supportsGroupBy()`
`boolean`
`supportsGroupByBeyondSelect()`
`boolean`
`supportsGroupByUnrelated()`
`boolean`
`supportsIntegrityEnhancementFacility()`
`boolean`
`supportsLikeEscapeClause()`
`boolean`
`supportsLimitedOuterJoins()`
`boolean`
`supportsMinimumSQLGrammar()`
`boolean`
`supportsMixedCaseIdentifiers()`
`boolean`
`supportsMixedCaseQuotedIdentifiers()`
`boolean`
`supportsMultipleOpenResults()`
`boolean`
`supportsMultipleResultSets()`
`boolean`
`supportsMultipleTransactions()`
`boolean`
`supportsNamedParameters()`
`boolean`
`supportsNonNullableColumns()`
`boolean`
`supportsOpenCursorsAcrossCommit()`
`boolean`
`supportsOpenCursorsAcrossRollback()`
`boolean`
`supportsOpenStatementsAcrossCommit()`
`boolean`
`supportsOpenStatementsAcrossRollback()`
`boolean`
`supportsOrderByUnrelated()`
`boolean`
`supportsOuterJoins()`
`boolean`
`supportsPositionedDelete()`
`boolean`
`supportsPositionedUpdate()`
`boolean`
`supportsResultSetConcurrency(int type, int concurrency)`
Retrieves whether this database supports the given concurrency type in combination with the given result set type.
`boolean`
`supportsResultSetHoldability(int holdability)`
`boolean`
`supportsResultSetType(int type)`
Retrieves whether this database supports the given result set type.
`boolean`
`supportsSavepoints()`
`boolean`
`supportsSchemasInDataManipulation()`
`boolean`
`supportsSchemasInIndexDefinitions()`
`boolean`
`supportsSchemasInPrivilegeDefinitions()`
`boolean`
`supportsSchemasInProcedureCalls()`
`boolean`
`supportsSchemasInTableDefinitions()`
`boolean`
`supportsSelectForUpdate()`
`boolean`
`supportsStatementPooling()`
`boolean`
`supportsStoredFunctionsUsingCallSyntax()`
`boolean`
`supportsStoredProcedures()`
`boolean`
`supportsSubqueriesInComparisons()`
`boolean`
`supportsSubqueriesInExists()`
`boolean`
`supportsSubqueriesInIns()`
`boolean`
`supportsSubqueriesInQuantifieds()`
`boolean`
`supportsTableCorrelationNames()`
`boolean`
`supportsTransactionIsolationLevel(int level)`
Retrieves whether this database supports the given transaction isolation level.
`boolean`
`supportsTransactions()`
Retrieves whether this database supports transactions.
`boolean`
`supportsUnion()`
`boolean`
`supportsUnionAll()`
`<T> T`
`unwrap(Class<T> iface)`
`boolean`
`updatesAreDetected(int type)`
`boolean`
`usesLocalFilePerTable()`
`boolean`
`usesLocalFiles()`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface java.sql.DatabaseMetaData

`supportsRefCursors, supportsSharding`

## Field Details

### DRIVER_NAME

public static final String DRIVER_NAME
MariaDB driver name

See Also:
  - Constant Field Values

## Constructor Details

### DatabaseMetaData

public DatabaseMetaData(Connection connection, Configuration conf)
Constructor.

Parameters:
  `connection` - connection
  `conf` - configuration

## Method Details

### escapeString

public static String escapeString(String value, boolean noBackslashEscapes)
Escape String.

Parameters:
  `value` - value to escape
  `noBackslashEscapes` - must backslash be escaped
Returns:
  escaped string.

### getImportedKeys

public ResultSet getImportedKeys(String catalog, String schema, String table) throws SQLException
Retrieves a description of the primary key columns that are referenced by the given table's foreign key columns (the primary keys imported by a table). They are ordered by PKTABLE_CAT, PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.

Each primary key column description has the following columns:

1. PKTABLE_CAT String `=>` primary key table catalog being imported (may be `null`)
2. PKTABLE_SCHEM String `=>` primary key table schema being imported (may be `null`)
3. PKTABLE_NAME String `=>` primary key table name being imported
4. PKCOLUMN_NAME String `=>` primary key column name being imported
5. FKTABLE_CAT String `=>` foreign key table catalog (may be `null`)
6. FKTABLE_SCHEM String `=>` foreign key table schema (may be `null` )
7. FKTABLE_NAME String `=>` foreign key table name
8. FKCOLUMN_NAME String `=>` foreign key column name
9. KEY_SEQ short `=>` sequence number within a foreign key( a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
10. UPDATE_RULE short `=>` What happens to a foreign key when the primary key is updated:
    - importedNoAction - do not allow update of primary key if it has been imported
    - importedKeyCascade - change imported key to agree with primary key update
    - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
    - importedKeySetDefault - change imported key to default values if its primary key has been updated
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
11. DELETE_RULE short `=>` What happens to the foreign key when primary is deleted.
    - importedKeyNoAction - do not allow delete of primary key if it has been imported
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeySetNull - change imported key to NULL if its primary key has been deleted
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
    - importedKeySetDefault - change imported key to default if its primary key has been deleted
12. FK_NAME String `=>` foreign key name (may be `null`)
13. PK_NAME String `=>` primary key name (may be `null`)
14. DEFERRABILITY short `=>` can the evaluation of foreign key constraints be deferred until commit
    - importedKeyInitiallyDeferred - see SQL92 for definition
    - importedKeyInitiallyImmediate - see SQL92 for definition
    - importedKeyNotDeferrable - see SQL92 for definition

Specified by:
  `getImportedKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in the database
Returns:
  `ResultSet` - each row is a primary key column description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getExportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getPrimaryKeys

public ResultSet getPrimaryKeys(String catalog, String schema, String table) throws SQLException
Retrieves a description of the given table's primary key columns. They are ordered by COLUMN_NAME.

Each primary key column description has the following columns:

1. TABLE_CAT String `=>` table catalog
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. COLUMN_NAME String `=>` column name
5. KEY_SEQ short `=>` sequence number within primary key( a value of 1 represents the first column of the primary key, a value of 2 would represent the second column within the primary key).
6. PK_NAME String `=>` primary key name

Specified by:
  `getPrimaryKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in the database
Returns:
  `ResultSet` - each row is a primary key column description
Throws:
  `SQLException` - if a database access error occurs

### getTables

public ResultSet getTables(String catalog, String schemaPattern, String tableNamePattern, String[] types) throws SQLException
Retrieves a description of the tables available in the given catalog. Only table descriptions matching the catalog, schema, table name and type criteria are returned. They are ordered by `TABLE_TYPE`, `TABLE_CAT`, `TABLE_SCHEM` and `TABLE_NAME` . Each table description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. TABLE_TYPE String `=>` table type. Typical types are "TABLE", "VIEW", "SYSTEM TABLE", "GLOBAL TEMPORARY", "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
5. REMARKS String `=>` explanatory comment on the table
6. TYPE_CAT String `=>` the types catalog (may be `null`)
7. TYPE_SCHEM String `=>` the types schema (may be `null`)
8. TYPE_NAME String `=>` type name (may be `null`)
9. SELF_REFERENCING_COL_NAME String `=>` name of the designated "identifier" column of a typed table (may be `null`)
10. REF_GENERATION String `=>` specifies how values in SELF_REFERENCING_COL_NAME are created. Values are "SYSTEM", "USER", "DERIVED". (may be `null`)

Note: Some databases may not return information for all tables.

Specified by:
  `getTables` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
  `types` - a list of table types, which must be from the list of table types returned from `getTableTypes()`,to include; `null` returns all types
Returns:
  `ResultSet` - each row is a table description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getColumns

public ResultSet getColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern) throws SQLException
Retrieves a description of table columns available in the specified catalog.

Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by `TABLE_CAT`,`TABLE_SCHEM`, `TABLE_NAME` , and `ORDINAL_POSITION`.

Each column description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. COLUMN_NAME String `=>` column name
5. DATA_TYPE int `=>` SQL type from java.sql.Types
6. TYPE_NAME String `=>` Data source dependent type name, for a UDT the type name is fully qualified
7. COLUMN_SIZE int `=>` column size.
8. BUFFER_LENGTH is not used.
9. DECIMAL_DIGITS int `=>` the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
10. NUM_PREC_RADIX int `=>` Radix (typically either 10 or 2)
11. NULLABLE int `=>` is NULL allowed.
    - columnNoNulls - might not allow `NULL` values
    - columnNullable - definitely allows `NULL` values
    - columnNullableUnknown - nullability unknown
12. REMARKS String `=>` comment describing column (may be `null`)
13. COLUMN_DEF String `=>` default value for the column, which should be interpreted as a string when the value is enclosed in single quotes (may be `null` )
14. SQL_DATA_TYPE int `=>` unused
15. SQL_DATETIME_SUB int `=>` unused
16. CHAR_OCTET_LENGTH int `=>` for char types the maximum number of bytes in the column
17. ORDINAL_POSITION int `=>` index of column in table (starting at 1)
18. IS_NULLABLE String `=>` ISO rules are used to determine the nullability for a column.
    - YES --- if the column can include NULLs
    - NO --- if the column cannot include NULLs
    - empty string --- if the nullability for the column is unknown
19. SCOPE_CATALOG String `=>` catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
20. SCOPE_SCHEMA String `=>` schema of table that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
21. SCOPE_TABLE String `=>` table name that this the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
22. SOURCE_DATA_TYPE short `=>` source type of a distinct type or user-generated Ref type, SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)
23. IS_AUTOINCREMENT String `=>` Indicates whether this column is auto incremented
    - YES --- if the column is auto incremented
    - NO --- if the column is not auto incremented
    - empty string --- if it cannot be determined whether the column is auto incremented
24. IS_GENERATEDCOLUMN String `=>` Indicates whether this is a generated column
    - YES --- if this a generated column
    - NO --- if this not a generated column
    - empty string --- if it cannot be determined whether this is a generated column

The COLUMN_SIZE column specifies the column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
  `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
Returns:
  `ResultSet` - each row is a column description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getExportedKeys

public ResultSet getExportedKeys(String catalog, String schema, String table) throws SQLException
Retrieves a description of the foreign key columns that reference the given table's primary key columns (the foreign keys exported by a table). They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

Each foreign key column description has the following columns:

1. PKTABLE_CAT String `=>` primary key table catalog (may be `null`)
2. PKTABLE_SCHEM String `=>` primary key table schema (may be `null` )
3. PKTABLE_NAME String `=>` primary key table name
4. PKCOLUMN_NAME String `=>` primary key column name
5. FKTABLE_CAT String `=>` foreign key table catalog (may be `null`) being exported (may be `null`)
6. FKTABLE_SCHEM String `=>` foreign key table schema (may be `null` ) being exported (may be `null`)
7. FKTABLE_NAME String `=>` foreign key table name being exported
8. FKCOLUMN_NAME String `=>` foreign key column name being exported
9. KEY_SEQ short `=>` sequence number within foreign key( a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
10. UPDATE_RULE short `=>` What happens to foreign key when primary is updated:
    - importedNoAction - do not allow update of primary key if it has been imported
    - importedKeyCascade - change imported key to agree with primary key update
    - importedKeySetNull - change imported key to `NULL` if its primary key has been updated
    - importedKeySetDefault - change imported key to default values if its primary key has been updated
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
11. DELETE_RULE short `=>` What happens to the foreign key when primary is deleted.
    - importedKeyNoAction - do not allow delete of primary key if it has been imported
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
    - importedKeySetDefault - change imported key to default if its primary key has been deleted
12. FK_NAME String `=>` foreign key name (may be `null`)
13. PK_NAME String `=>` primary key name (may be `null`)
14. DEFERRABILITY short `=>` can the evaluation of foreign key constraints be deferred until commit
    - importedKeyInitiallyDeferred - see SQL92 for definition
    - importedKeyInitiallyImmediate - see SQL92 for definition
    - importedKeyNotDeferrable - see SQL92 for definition

Specified by:
  `getExportedKeys` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in this database
Returns:
  a `ResultSet` object in which each row is a foreign key column description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getImportedKeysUsingInformationSchema

public ResultSet getImportedKeysUsingInformationSchema(String database, String table) throws SQLException
GetImportedKeysUsingInformationSchema.

Parameters:
  `database` - database
  `table` - table
Returns:
  resultset
Throws:
  `SQLException` - exception

### getImportedKeysUsingShowCreateTable

public ResultSet getImportedKeysUsingShowCreateTable(String database, String table) throws Exception
GetImportedKeysUsingShowCreateTable.

Parameters:
  `database` - database
  `table` - table
Returns:
  resultset
Throws:
  `Exception` - exception

### getBestRowIdentifier

public ResultSet getBestRowIdentifier(String catalog, String schema, String table, int scope, boolean nullable) throws SQLException
Retrieves a description of a table's optimal set of columns that uniquely identifies a row. They are ordered by SCOPE.

Each column description has the following columns:

1. SCOPE short `=>` actual scope of result
   - bestRowTemporary - very temporary, while using row
   - bestRowTransaction - valid for remainder of current transaction
   - bestRowSession - valid for remainder of current session
2. COLUMN_NAME String `=>` column name
3. DATA_TYPE int `=>` SQL data type from java.sql.Types
4. TYPE_NAME String `=>` Data source dependent type name, for a UDT the type name is fully qualified
5. COLUMN_SIZE int `=>` precision
6. BUFFER_LENGTH int `=>` not used
7. DECIMAL_DIGITS short `=>` scale - Null is returned for data types where DECIMAL_DIGITS is not applicable.
8. PSEUDO_COLUMN short `=>` is this a pseudo column like an Oracle ROWID
   - bestRowUnknown - may or may not be pseudo column
   - bestRowNotPseudo - is NOT a pseudo column
   - bestRowPseudo - is a pseudo column

The COLUMN_SIZE column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getBestRowIdentifier` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in the database
  `scope` - the scope of interest; use same values as SCOPE
  `nullable` - include columns that are nullable.
Returns:
  `ResultSet` - each row is a column description
Throws:
  `SQLException` - if a database access error occurs

### generatedKeyAlwaysReturned

public boolean generatedKeyAlwaysReturned()

Specified by:
  `generatedKeyAlwaysReturned` in interface `DatabaseMetaData`

### getPseudoColumns

public ResultSet getPseudoColumns(String catalog, String schemaPattern, String tableNamePattern, String columnNamePattern) throws SQLException
Retrieves a description of the pseudo or hidden columns available in a given table within the specified catalog and schema. Pseudo or hidden columns may not always be stored within a table and are not visible in a ResultSet unless they are specified in the query's outermost SELECT list. Pseudo or hidden columns may not necessarily be able to be modified. If there are no pseudo or hidden columns, an empty ResultSet is returned.

Only column descriptions matching the catalog, schema, table and column name criteria are returned. They are ordered by `TABLE_CAT`,`TABLE_SCHEM`, `TABLE_NAME` and `COLUMN_NAME`.

Each column description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. COLUMN_NAME String `=>` column name
5. DATA_TYPE int `=>` SQL type from java.sql.Types
6. COLUMN_SIZE int `=>` column size.
7. DECIMAL_DIGITS int `=>` the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
8. NUM_PREC_RADIX int `=>` Radix (typically either 10 or 2)
9. COLUMN_USAGE String `=>` The allowed usage for the column. The value returned will correspond to the enum name returned by PseudoColumnUsage.name()
10. REMARKS String `=>` comment describing column (may be `null`)
11. CHAR_OCTET_LENGTH int `=>` for char types the maximum number of bytes in the column
12. IS_NULLABLE String `=>` ISO rules are used to determine the nullability for a column.
    - YES --- if the column can include NULLs
    - NO --- if the column cannot include NULLs
    - empty string --- if the nullability for the column is unknown

The COLUMN_SIZE column specifies the column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getPseudoColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
  `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
Returns:
  `ResultSet` - each row is a column description
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.7
See Also:
  - `PseudoColumnUsage`

### allProceduresAreCallable

public boolean allProceduresAreCallable()

Specified by:
  `allProceduresAreCallable` in interface `DatabaseMetaData`

### allTablesAreSelectable

public boolean allTablesAreSelectable()

Specified by:
  `allTablesAreSelectable` in interface `DatabaseMetaData`

### getURL

public String getURL()

Specified by:
  `getURL` in interface `DatabaseMetaData`

### getUserName

public String getUserName()

Specified by:
  `getUserName` in interface `DatabaseMetaData`

### isReadOnly

public boolean isReadOnly() throws SQLException

Specified by:
  `isReadOnly` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### nullsAreSortedHigh

public boolean nullsAreSortedHigh()

Specified by:
  `nullsAreSortedHigh` in interface `DatabaseMetaData`

### nullsAreSortedLow

public boolean nullsAreSortedLow()

Specified by:
  `nullsAreSortedLow` in interface `DatabaseMetaData`

### nullsAreSortedAtStart

public boolean nullsAreSortedAtStart()

Specified by:
  `nullsAreSortedAtStart` in interface `DatabaseMetaData`

### nullsAreSortedAtEnd

public boolean nullsAreSortedAtEnd()

Specified by:
  `nullsAreSortedAtEnd` in interface `DatabaseMetaData`

### getDatabaseProductName

public String getDatabaseProductName()
Return Server type. MySQL or MariaDB. MySQL can be forced for compatibility with option "useMysqlMetadata"

Specified by:
  `getDatabaseProductName` in interface `DatabaseMetaData`
Returns:
  server type

### getDatabaseProductVersion

public String getDatabaseProductVersion()

Specified by:
  `getDatabaseProductVersion` in interface `DatabaseMetaData`

### getDriverName

public String getDriverName()

Specified by:
  `getDriverName` in interface `DatabaseMetaData`

### getDriverVersion

public String getDriverVersion()

Specified by:
  `getDriverVersion` in interface `DatabaseMetaData`

### getDriverMajorVersion

public int getDriverMajorVersion()

Specified by:
  `getDriverMajorVersion` in interface `DatabaseMetaData`

### getDriverMinorVersion

public int getDriverMinorVersion()

Specified by:
  `getDriverMinorVersion` in interface `DatabaseMetaData`

### usesLocalFiles

public boolean usesLocalFiles()

Specified by:
  `usesLocalFiles` in interface `DatabaseMetaData`

### usesLocalFilePerTable

public boolean usesLocalFilePerTable()

Specified by:
  `usesLocalFilePerTable` in interface `DatabaseMetaData`

### supportsMixedCaseIdentifiers

public boolean supportsMixedCaseIdentifiers() throws SQLException

Specified by:
  `supportsMixedCaseIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### storesUpperCaseIdentifiers

public boolean storesUpperCaseIdentifiers()

Specified by:
  `storesUpperCaseIdentifiers` in interface `DatabaseMetaData`

### storesLowerCaseIdentifiers

public boolean storesLowerCaseIdentifiers() throws SQLException

Specified by:
  `storesLowerCaseIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### storesMixedCaseIdentifiers

public boolean storesMixedCaseIdentifiers() throws SQLException

Specified by:
  `storesMixedCaseIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### supportsMixedCaseQuotedIdentifiers

public boolean supportsMixedCaseQuotedIdentifiers() throws SQLException

Specified by:
  `supportsMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### storesUpperCaseQuotedIdentifiers

public boolean storesUpperCaseQuotedIdentifiers()

Specified by:
  `storesUpperCaseQuotedIdentifiers` in interface `DatabaseMetaData`

### storesLowerCaseQuotedIdentifiers

public boolean storesLowerCaseQuotedIdentifiers() throws SQLException

Specified by:
  `storesLowerCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### storesMixedCaseQuotedIdentifiers

public boolean storesMixedCaseQuotedIdentifiers() throws SQLException

Specified by:
  `storesMixedCaseQuotedIdentifiers` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### getIdentifierQuoteString

public String getIdentifierQuoteString()

Specified by:
  `getIdentifierQuoteString` in interface `DatabaseMetaData`

### getSQLKeywords

public String getSQLKeywords()
Retrieves a comma-separated list of all of this database's SQL keywords that are NOT also SQL:2003 keywords.

Specified by:
  `getSQLKeywords` in interface `DatabaseMetaData`
Returns:
  the list of this database's keywords that are not also SQL:2003 keywords

### getNumericFunctions

public String getNumericFunctions()
List of numeric functions.

Specified by:
  `getNumericFunctions` in interface `DatabaseMetaData`
Returns:
  List of numeric functions.

### getStringFunctions

public String getStringFunctions()
List of string functions.

Specified by:
  `getStringFunctions` in interface `DatabaseMetaData`
Returns:
  List of string functions.

### getSystemFunctions

public String getSystemFunctions()
List of system functions.

Specified by:
  `getSystemFunctions` in interface `DatabaseMetaData`
Returns:
  List of system functions.

### getTimeDateFunctions

public String getTimeDateFunctions()
List of time and date functions.

Specified by:
  `getTimeDateFunctions` in interface `DatabaseMetaData`
Returns:
  List of time and date functions.

### getSearchStringEscape

public String getSearchStringEscape()

Specified by:
  `getSearchStringEscape` in interface `DatabaseMetaData`

### getExtraNameCharacters

public String getExtraNameCharacters()

Specified by:
  `getExtraNameCharacters` in interface `DatabaseMetaData`

### supportsAlterTableWithAddColumn

public boolean supportsAlterTableWithAddColumn()

Specified by:
  `supportsAlterTableWithAddColumn` in interface `DatabaseMetaData`

### supportsAlterTableWithDropColumn

public boolean supportsAlterTableWithDropColumn()

Specified by:
  `supportsAlterTableWithDropColumn` in interface `DatabaseMetaData`

### supportsColumnAliasing

public boolean supportsColumnAliasing()

Specified by:
  `supportsColumnAliasing` in interface `DatabaseMetaData`

### nullPlusNonNullIsNull

public boolean nullPlusNonNullIsNull()

Specified by:
  `nullPlusNonNullIsNull` in interface `DatabaseMetaData`

### supportsConvert

public boolean supportsConvert()

Specified by:
  `supportsConvert` in interface `DatabaseMetaData`

### supportsConvert

public boolean supportsConvert(int fromType, int toType)
Retrieves whether this database supports the JDBC scalar function CONVERT for conversions between the JDBC types fromType and toType. The JDBC types are the generic SQL data types defined in java.sql.Types.

Specified by:
  `supportsConvert` in interface `DatabaseMetaData`
Parameters:
  `fromType` - the type to convert from; one of the type codes from the class java.sql.Types
  `toType` - the type to convert to; one of the type codes from the class java.sql.Types
Returns:
  true if so; false otherwise

### supportsTableCorrelationNames

public boolean supportsTableCorrelationNames()

Specified by:
  `supportsTableCorrelationNames` in interface `DatabaseMetaData`

### supportsDifferentTableCorrelationNames

public boolean supportsDifferentTableCorrelationNames()

Specified by:
  `supportsDifferentTableCorrelationNames` in interface `DatabaseMetaData`

### supportsExpressionsInOrderBy

public boolean supportsExpressionsInOrderBy()

Specified by:
  `supportsExpressionsInOrderBy` in interface `DatabaseMetaData`

### supportsOrderByUnrelated

public boolean supportsOrderByUnrelated()

Specified by:
  `supportsOrderByUnrelated` in interface `DatabaseMetaData`

### supportsGroupBy

public boolean supportsGroupBy()

Specified by:
  `supportsGroupBy` in interface `DatabaseMetaData`

### supportsGroupByUnrelated

public boolean supportsGroupByUnrelated()

Specified by:
  `supportsGroupByUnrelated` in interface `DatabaseMetaData`

### supportsGroupByBeyondSelect

public boolean supportsGroupByBeyondSelect()

Specified by:
  `supportsGroupByBeyondSelect` in interface `DatabaseMetaData`

### supportsLikeEscapeClause

public boolean supportsLikeEscapeClause()

Specified by:
  `supportsLikeEscapeClause` in interface `DatabaseMetaData`

### supportsMultipleResultSets

public boolean supportsMultipleResultSets()

Specified by:
  `supportsMultipleResultSets` in interface `DatabaseMetaData`

### supportsMultipleTransactions

public boolean supportsMultipleTransactions()

Specified by:
  `supportsMultipleTransactions` in interface `DatabaseMetaData`

### supportsNonNullableColumns

public boolean supportsNonNullableColumns()

Specified by:
  `supportsNonNullableColumns` in interface `DatabaseMetaData`

### supportsMinimumSQLGrammar

public boolean supportsMinimumSQLGrammar()

Specified by:
  `supportsMinimumSQLGrammar` in interface `DatabaseMetaData`

### supportsCoreSQLGrammar

public boolean supportsCoreSQLGrammar()

Specified by:
  `supportsCoreSQLGrammar` in interface `DatabaseMetaData`

### supportsExtendedSQLGrammar

public boolean supportsExtendedSQLGrammar()

Specified by:
  `supportsExtendedSQLGrammar` in interface `DatabaseMetaData`

### supportsANSI92EntryLevelSQL

public boolean supportsANSI92EntryLevelSQL()

Specified by:
  `supportsANSI92EntryLevelSQL` in interface `DatabaseMetaData`

### supportsANSI92IntermediateSQL

public boolean supportsANSI92IntermediateSQL()

Specified by:
  `supportsANSI92IntermediateSQL` in interface `DatabaseMetaData`

### supportsANSI92FullSQL

public boolean supportsANSI92FullSQL()

Specified by:
  `supportsANSI92FullSQL` in interface `DatabaseMetaData`

### supportsIntegrityEnhancementFacility

public boolean supportsIntegrityEnhancementFacility()

Specified by:
  `supportsIntegrityEnhancementFacility` in interface `DatabaseMetaData`

### supportsOuterJoins

public boolean supportsOuterJoins()

Specified by:
  `supportsOuterJoins` in interface `DatabaseMetaData`

### supportsFullOuterJoins

public boolean supportsFullOuterJoins()

Specified by:
  `supportsFullOuterJoins` in interface `DatabaseMetaData`

### supportsLimitedOuterJoins

public boolean supportsLimitedOuterJoins()

Specified by:
  `supportsLimitedOuterJoins` in interface `DatabaseMetaData`

### getSchemaTerm

public String getSchemaTerm()

Specified by:
  `getSchemaTerm` in interface `DatabaseMetaData`

### getProcedureTerm

public String getProcedureTerm()

Specified by:
  `getProcedureTerm` in interface `DatabaseMetaData`

### getCatalogTerm

public String getCatalogTerm()

Specified by:
  `getCatalogTerm` in interface `DatabaseMetaData`

### isCatalogAtStart

public boolean isCatalogAtStart()

Specified by:
  `isCatalogAtStart` in interface `DatabaseMetaData`

### getCatalogSeparator

public String getCatalogSeparator()

Specified by:
  `getCatalogSeparator` in interface `DatabaseMetaData`

### supportsSchemasInDataManipulation

public boolean supportsSchemasInDataManipulation()

Specified by:
  `supportsSchemasInDataManipulation` in interface `DatabaseMetaData`

### supportsSchemasInProcedureCalls

public boolean supportsSchemasInProcedureCalls()

Specified by:
  `supportsSchemasInProcedureCalls` in interface `DatabaseMetaData`

### supportsSchemasInTableDefinitions

public boolean supportsSchemasInTableDefinitions()

Specified by:
  `supportsSchemasInTableDefinitions` in interface `DatabaseMetaData`

### supportsSchemasInIndexDefinitions

public boolean supportsSchemasInIndexDefinitions()

Specified by:
  `supportsSchemasInIndexDefinitions` in interface `DatabaseMetaData`

### supportsSchemasInPrivilegeDefinitions

public boolean supportsSchemasInPrivilegeDefinitions()

Specified by:
  `supportsSchemasInPrivilegeDefinitions` in interface `DatabaseMetaData`

### supportsCatalogsInDataManipulation

public boolean supportsCatalogsInDataManipulation()

Specified by:
  `supportsCatalogsInDataManipulation` in interface `DatabaseMetaData`

### supportsCatalogsInProcedureCalls

public boolean supportsCatalogsInProcedureCalls()

Specified by:
  `supportsCatalogsInProcedureCalls` in interface `DatabaseMetaData`

### supportsCatalogsInTableDefinitions

public boolean supportsCatalogsInTableDefinitions()

Specified by:
  `supportsCatalogsInTableDefinitions` in interface `DatabaseMetaData`

### supportsCatalogsInIndexDefinitions

public boolean supportsCatalogsInIndexDefinitions()

Specified by:
  `supportsCatalogsInIndexDefinitions` in interface `DatabaseMetaData`

### supportsCatalogsInPrivilegeDefinitions

public boolean supportsCatalogsInPrivilegeDefinitions()

Specified by:
  `supportsCatalogsInPrivilegeDefinitions` in interface `DatabaseMetaData`

### supportsPositionedDelete

public boolean supportsPositionedDelete()

Specified by:
  `supportsPositionedDelete` in interface `DatabaseMetaData`

### supportsPositionedUpdate

public boolean supportsPositionedUpdate()

Specified by:
  `supportsPositionedUpdate` in interface `DatabaseMetaData`

### supportsSelectForUpdate

public boolean supportsSelectForUpdate()

Specified by:
  `supportsSelectForUpdate` in interface `DatabaseMetaData`

### supportsStoredProcedures

public boolean supportsStoredProcedures()

Specified by:
  `supportsStoredProcedures` in interface `DatabaseMetaData`

### supportsSubqueriesInComparisons

public boolean supportsSubqueriesInComparisons()

Specified by:
  `supportsSubqueriesInComparisons` in interface `DatabaseMetaData`

### supportsSubqueriesInExists

public boolean supportsSubqueriesInExists()

Specified by:
  `supportsSubqueriesInExists` in interface `DatabaseMetaData`

### supportsSubqueriesInIns

public boolean supportsSubqueriesInIns()

Specified by:
  `supportsSubqueriesInIns` in interface `DatabaseMetaData`

### supportsSubqueriesInQuantifieds

public boolean supportsSubqueriesInQuantifieds()

Specified by:
  `supportsSubqueriesInQuantifieds` in interface `DatabaseMetaData`

### supportsCorrelatedSubqueries

public boolean supportsCorrelatedSubqueries()

Specified by:
  `supportsCorrelatedSubqueries` in interface `DatabaseMetaData`

### supportsUnion

public boolean supportsUnion()

Specified by:
  `supportsUnion` in interface `DatabaseMetaData`

### supportsUnionAll

public boolean supportsUnionAll()

Specified by:
  `supportsUnionAll` in interface `DatabaseMetaData`

### supportsOpenCursorsAcrossCommit

public boolean supportsOpenCursorsAcrossCommit()

Specified by:
  `supportsOpenCursorsAcrossCommit` in interface `DatabaseMetaData`

### supportsOpenCursorsAcrossRollback

public boolean supportsOpenCursorsAcrossRollback()

Specified by:
  `supportsOpenCursorsAcrossRollback` in interface `DatabaseMetaData`

### supportsOpenStatementsAcrossCommit

public boolean supportsOpenStatementsAcrossCommit()

Specified by:
  `supportsOpenStatementsAcrossCommit` in interface `DatabaseMetaData`

### supportsOpenStatementsAcrossRollback

public boolean supportsOpenStatementsAcrossRollback()

Specified by:
  `supportsOpenStatementsAcrossRollback` in interface `DatabaseMetaData`

### getMaxBinaryLiteralLength

public int getMaxBinaryLiteralLength()

Specified by:
  `getMaxBinaryLiteralLength` in interface `DatabaseMetaData`

### getMaxCharLiteralLength

public int getMaxCharLiteralLength()

Specified by:
  `getMaxCharLiteralLength` in interface `DatabaseMetaData`

### getMaxColumnNameLength

public int getMaxColumnNameLength()

Specified by:
  `getMaxColumnNameLength` in interface `DatabaseMetaData`

### getMaxColumnsInGroupBy

public int getMaxColumnsInGroupBy()

Specified by:
  `getMaxColumnsInGroupBy` in interface `DatabaseMetaData`

### getMaxColumnsInIndex

public int getMaxColumnsInIndex()

Specified by:
  `getMaxColumnsInIndex` in interface `DatabaseMetaData`

### getMaxColumnsInOrderBy

public int getMaxColumnsInOrderBy()

Specified by:
  `getMaxColumnsInOrderBy` in interface `DatabaseMetaData`

### getMaxColumnsInSelect

public int getMaxColumnsInSelect()

Specified by:
  `getMaxColumnsInSelect` in interface `DatabaseMetaData`

### getMaxColumnsInTable

public int getMaxColumnsInTable()

Specified by:
  `getMaxColumnsInTable` in interface `DatabaseMetaData`

### getMaxConnections

public int getMaxConnections()

Specified by:
  `getMaxConnections` in interface `DatabaseMetaData`

### getMaxCursorNameLength

public int getMaxCursorNameLength()

Specified by:
  `getMaxCursorNameLength` in interface `DatabaseMetaData`

### getMaxIndexLength

public int getMaxIndexLength()

Specified by:
  `getMaxIndexLength` in interface `DatabaseMetaData`

### getMaxSchemaNameLength

public int getMaxSchemaNameLength()

Specified by:
  `getMaxSchemaNameLength` in interface `DatabaseMetaData`

### getMaxProcedureNameLength

public int getMaxProcedureNameLength()

Specified by:
  `getMaxProcedureNameLength` in interface `DatabaseMetaData`

### getMaxCatalogNameLength

public int getMaxCatalogNameLength()

Specified by:
  `getMaxCatalogNameLength` in interface `DatabaseMetaData`

### getMaxRowSize

public int getMaxRowSize()

Specified by:
  `getMaxRowSize` in interface `DatabaseMetaData`

### doesMaxRowSizeIncludeBlobs

public boolean doesMaxRowSizeIncludeBlobs()

Specified by:
  `doesMaxRowSizeIncludeBlobs` in interface `DatabaseMetaData`

### getMaxStatementLength

public int getMaxStatementLength()

Specified by:
  `getMaxStatementLength` in interface `DatabaseMetaData`

### getMaxStatements

public int getMaxStatements()

Specified by:
  `getMaxStatements` in interface `DatabaseMetaData`

### getMaxTableNameLength

public int getMaxTableNameLength()

Specified by:
  `getMaxTableNameLength` in interface `DatabaseMetaData`

### getMaxTablesInSelect

public int getMaxTablesInSelect()

Specified by:
  `getMaxTablesInSelect` in interface `DatabaseMetaData`

### getMaxUserNameLength

public int getMaxUserNameLength()

Specified by:
  `getMaxUserNameLength` in interface `DatabaseMetaData`

### getDefaultTransactionIsolation

public int getDefaultTransactionIsolation()

Specified by:
  `getDefaultTransactionIsolation` in interface `DatabaseMetaData`

### supportsTransactions

public boolean supportsTransactions()
Retrieves whether this database supports transactions. If not, invoking the method `commit` is a noop, and the isolation level is `TRANSACTION_NONE`.

Specified by:
  `supportsTransactions` in interface `DatabaseMetaData`
Returns:
  `true` if transactions are supported; `false` otherwise

### supportsTransactionIsolationLevel

public boolean supportsTransactionIsolationLevel(int level)
Retrieves whether this database supports the given transaction isolation level.

Specified by:
  `supportsTransactionIsolationLevel` in interface `DatabaseMetaData`
Parameters:
  `level` - one of the transaction isolation levels defined in `java.sql.Connection`
Returns:
  `true` if so; `false` otherwise
See Also:
  - `Connection`

### supportsDataDefinitionAndDataManipulationTransactions

public boolean supportsDataDefinitionAndDataManipulationTransactions()

Specified by:
  `supportsDataDefinitionAndDataManipulationTransactions` in interface `DatabaseMetaData`

### supportsDataManipulationTransactionsOnly

public boolean supportsDataManipulationTransactionsOnly()

Specified by:
  `supportsDataManipulationTransactionsOnly` in interface `DatabaseMetaData`

### dataDefinitionCausesTransactionCommit

public boolean dataDefinitionCausesTransactionCommit()

Specified by:
  `dataDefinitionCausesTransactionCommit` in interface `DatabaseMetaData`

### dataDefinitionIgnoredInTransactions

public boolean dataDefinitionIgnoredInTransactions()

Specified by:
  `dataDefinitionIgnoredInTransactions` in interface `DatabaseMetaData`

### getProcedures

public ResultSet getProcedures(String catalog, String schemaPattern, String procedureNamePattern) throws SQLException
Retrieves a description of the stored procedures available in the given catalog. Only procedure descriptions matching the schema and procedure name criteria are returned. They are ordered by `PROCEDURE_CAT`, `PROCEDURE_SCHEM`, `PROCEDURE_NAME` and `SPECIFIC_ NAME`.

Each procedure description has the following columns:

1. PROCEDURE_CAT String `=>` procedure catalog (may be `null`)
2. PROCEDURE_SCHEM String `=>` procedure schema (may be `null`)
3. PROCEDURE_NAME String `=>` procedure name
4. reserved for future use
5. reserved for future use
6. reserved for future use
7. REMARKS String `=>` explanatory comment on the procedure
8. PROCEDURE_TYPE short `=>` kind of procedure:
   - procedureResultUnknown - Cannot determine if a return value will be returned
   - procedureNoResult - Does not return a return value
   - procedureReturnsResult - Returns a return value
9. SPECIFIC_NAME String `=>` The name which uniquely identifies this procedure within its schema.

A user may not have permissions to execute any of the procedures that are returned by `getProcedures`

Specified by:
  `getProcedures` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
Returns:
  `ResultSet` - each row is a procedure description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getProcedureColumns

public ResultSet getProcedureColumns(String catalog, String schemaPattern, String procedureNamePattern, String columnNamePattern) throws SQLException
Retrieves a description of the given catalog's stored procedure parameter and result columns.

Only descriptions matching the schema, procedure and parameter name criteria are returned. They are ordered by PROCEDURE_CAT, PROCEDURE_SCHEM, PROCEDURE_NAME and SPECIFIC_NAME. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

Each row in the `ResultSet` is a parameter description or column description with the following fields:

1. PROCEDURE_CAT String `=>` procedure catalog (may be `null`)
2. PROCEDURE_SCHEM String `=>` procedure schema (may be `null`)
3. PROCEDURE_NAME String `=>` procedure name
4. COLUMN_NAME String `=>` column/parameter name
5. COLUMN_TYPE Short `=>` kind of column/parameter:
   - procedureColumnUnknown - nobody knows
   - procedureColumnIn - IN parameter
   - procedureColumnInOut - INOUT parameter
   - procedureColumnOut - OUT parameter
   - procedureColumnReturn - procedure return value
   - procedureColumnResult - result column in `ResultSet`
6. DATA_TYPE int `=>` SQL type from java.sql.Types
7. TYPE_NAME String `=>` SQL type name, for a UDT type the type name is fully qualified
8. PRECISION int `=>` precision
9. LENGTH int `=>` length in bytes of data
10. SCALE short `=>` scale - null is returned for data types where SCALE is not applicable.
11. RADIX short `=>` radix
12. NULLABLE short `=>` can it contain NULL.
    - procedureNoNulls - does not allow NULL values
    - procedureNullable - allows NULL values
    - procedureNullableUnknown - nullability unknown
13. REMARKS String `=>` comment describing parameter/column
14. COLUMN_DEF String `=>` default value for the column, which should be interpreted as a string when the value is enclosed in single quotes (may be `null` )
    - The string NULL (not enclosed in quotes) - if NULL was specified as the default value
    - TRUNCATE (not enclosed in quotes) - if the specified default value cannot be represented without truncation
    - NULL - if a default value was not specified
15. SQL_DATA_TYPE int `=>` reserved for future use
16. SQL_DATETIME_SUB int `=>` reserved for future use
17. CHAR_OCTET_LENGTH int `=>` the maximum length of binary and character based columns. For any other datatype the returned value is a NULL
18. ORDINAL_POSITION int `=>` the ordinal position, starting from 1, for the input and output parameters for a procedure. A value of 0 is returned if this row describes the procedure's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1. If there are multiple result sets, the column ordinal positions are implementation defined.
19. IS_NULLABLE String `=>` ISO rules are used to determine the nullability for a column.
    - YES --- if the column can include NULLs
    - NO --- if the column cannot include NULLs
    - empty string --- if the nullability for the column is unknown
20. SPECIFIC_NAME String `=>` the name which uniquely identifies this procedure within its schema.

Note: Some databases may not return the column descriptions for a procedure.

The PRECISION column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getProcedureColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `procedureNamePattern` - a procedure name pattern; must match the procedure name as it is stored in the database
  `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
Returns:
  `ResultSet` - each row describes a stored procedure parameter or column
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getFunctionColumns

public ResultSet getFunctionColumns(String catalog, String schemaPattern, String functionNamePattern, String columnNamePattern) throws SQLException
Retrieves a description of the given catalog's system or user function parameters and return type.

Only descriptions matching the schema, function and parameter name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`. Within this, the return value, if any, is first. Next are the parameter descriptions in call order. The column descriptions follow in column number order.

Each row in the `ResultSet` is a parameter description, column description or return type description with the following fields:

1. FUNCTION_CAT String `=>` function catalog (may be `null`)
2. FUNCTION_SCHEM String `=>` function schema (may be `null`)
3. FUNCTION_NAME String `=>` function name. This is the name used to invoke the function
4. COLUMN_NAME String `=>` column/parameter name
5. COLUMN_TYPE Short `=>` kind of column/parameter:
   - functionColumnUnknown - nobody knows
   - functionColumnIn - IN parameter
   - functionColumnInOut - INOUT parameter
   - functionColumnOut - OUT parameter
   - functionColumnReturn - function return value
   - functionColumnResult - Indicates that the parameter or column is a column in the `ResultSet`
6. DATA_TYPE int `=>` SQL type from java.sql.Types
7. TYPE_NAME String `=>` SQL type name, for a UDT type the type name is fully qualified
8. PRECISION int `=>` precision
9. LENGTH int `=>` length in bytes of data
10. SCALE short `=>` scale - null is returned for data types where SCALE is not applicable.
11. RADIX short `=>` radix
12. NULLABLE short `=>` can it contain NULL.
    - functionNoNulls - does not allow NULL values
    - functionNullable - allows NULL values
    - functionNullableUnknown - nullability unknown
13. REMARKS String `=>` comment describing column/parameter
14. CHAR_OCTET_LENGTH int `=>` the maximum length of binary and character based parameters or columns. For any other datatype the returned value is a NULL
15. ORDINAL_POSITION int `=>` the ordinal position, starting from 1, for the input and output parameters. A value of 0 is returned if this row describes the function's return value. For result set columns, it is the ordinal position of the column in the result set starting from 1.
16. IS_NULLABLE String `=>` ISO rules are used to determine the nullability for a parameter or column.
    - YES --- if the parameter or column can include NULLs
    - NO --- if the parameter or column cannot include NULLs
    - empty string --- if the nullability for the parameter or column is unknown
17. SPECIFIC_NAME String `=>` the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

The PRECISION column represents the specified column size for the given parameter or column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getFunctionColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `functionNamePattern` - a procedure name pattern; must match the function name as it is stored in the database
  `columnNamePattern` - a parameter name pattern; must match the parameter or column name as it is stored in the database
Returns:
  `ResultSet` - each row describes a user function parameter, column or return type
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.6
See Also:
  - `getSearchStringEscape()`

### getSchemas

public ResultSet getSchemas() throws SQLException

Specified by:
  `getSchemas` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### getSchemas

public ResultSet getSchemas(String catalog, String schemaPattern) throws SQLException

Specified by:
  `getSchemas` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### getCatalogs

public ResultSet getCatalogs() throws SQLException

Specified by:
  `getCatalogs` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### getTableTypes

public ResultSet getTableTypes() throws SQLException

Specified by:
  `getTableTypes` in interface `DatabaseMetaData`
Throws:
  `SQLException`

### getColumnPrivileges

public ResultSet getColumnPrivileges(String catalog, String schema, String table, String columnNamePattern) throws SQLException
Retrieves a description of the access rights for a table's columns.

Only privileges matching the column name criteria are returned. They are ordered by COLUMN_NAME and PRIVILEGE.

Each privilege description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. COLUMN_NAME String `=>` column name
5. GRANTOR String `=>` grantor of access (may be `null`)
6. GRANTEE String `=>` grantee of access
7. PRIVILEGE String `=>` name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
8. IS_GRANTABLE String `=>` "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

Specified by:
  `getColumnPrivileges` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in the database
  `columnNamePattern` - a column name pattern; must match the column name as it is stored in the database
Returns:
  `ResultSet` - each row is a column privilege description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getTablePrivileges

public ResultSet getTablePrivileges(String catalog, String schemaPattern, String tableNamePattern) throws SQLException
Retrieves a description of the access rights for each table available in a catalog. Note that a table privilege applies to one or more columns in the table. It would be wrong to assume that this privilege applies to all columns (this may be true for some systems but is not true for all.)

Only privileges matching the schema and table name criteria are returned. They are ordered by `TABLE_CAT`, `TABLE_SCHEM`, `TABLE_NAME`, and `PRIVILEGE`.

Each privilege description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. GRANTOR String `=>` grantor of access (may be `null`)
5. GRANTEE String `=>` grantee of access
6. PRIVILEGE String `=>` name of access (SELECT, INSERT, UPDATE, REFRENCES, ...)
7. IS_GRANTABLE String `=>` "YES" if grantee is permitted to grant to others; "NO" if not; `null` if unknown

Specified by:
  `getTablePrivileges` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `tableNamePattern` - a table name pattern; must match the table name as it is stored in the database
Returns:
  `ResultSet` - each row is a table privilege description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getSearchStringEscape()`

### getVersionColumns

public ResultSet getVersionColumns(String catalog, String schema, String table) throws SQLException
Retrieves a description of a table's columns that are automatically updated when any value in a row is updated. They are unordered.

Each column description has the following columns:

1. SCOPE short `=>` is not used
2. COLUMN_NAME String `=>` column name
3. DATA_TYPE int `=>` SQL data type from `java.sql.Types`
4. TYPE_NAME String `=>` Data source-dependent type name
5. COLUMN_SIZE int `=>` precision
6. BUFFER_LENGTH int `=>` length of column value in bytes
7. DECIMAL_DIGITS short `=>` scale - Null is returned for data types where DECIMAL_DIGITS is not applicable.
8. PSEUDO_COLUMN short `=>` whether this is pseudo column like an Oracle ROWID
   - versionColumnUnknown - may or may not be pseudo column
   - versionColumnNotPseudo - is NOT a pseudo column
   - versionColumnPseudo - is a pseudo column

The COLUMN_SIZE column represents the specified column size for the given column. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getVersionColumns` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog;`null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in the database
Returns:
  a `ResultSet` object in which each row is a column description
Throws:
  `SQLException` - if a database access error occurs

### getCrossReference

public ResultSet getCrossReference(String parentCatalog, String parentSchema, String parentTable, String foreignCatalog, String foreignSchema, String foreignTable) throws SQLException
Retrieves a description of the foreign key columns in the given foreign key table that reference the primary key or the columns representing a unique constraint of the parent table (could be the same or a different table). The number of columns returned from the parent table must match the number of columns that make up the foreign key. They are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and KEY_SEQ.

Each foreign key column description has the following columns:

1. PKTABLE_CAT String `=>` parent key table catalog (may be `null`)
2. PKTABLE_SCHEM String `=>` parent key table schema (may be `null`)
3. PKTABLE_NAME String `=>` parent key table name
4. PKCOLUMN_NAME String `=>` parent key column name
5. FKTABLE_CAT String `=>` foreign key table catalog (may be `null`) being exported (may be `null`)
6. FKTABLE_SCHEM String `=>` foreign key table schema (may be `null` ) being exported (may be `null`)
7. FKTABLE_NAME String `=>` foreign key table name being exported
8. FKCOLUMN_NAME String `=>` foreign key column name being exported
9. KEY_SEQ short `=>` sequence number within foreign key( a value of 1 represents the first column of the foreign key, a value of 2 would represent the second column within the foreign key).
10. UPDATE_RULE short `=>` What happens to foreign key when parent key is updated:
    - importedNoAction - do not allow update of parent key if it has been imported
    - importedKeyCascade - change imported key to agree with parent key update
    - importedKeySetNull - change imported key to `NULL` if its parent key has been updated
    - importedKeySetDefault - change imported key to default values if its parent key has been updated
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
11. DELETE_RULE short `=>` What happens to the foreign key when parent key is deleted.
    - importedKeyNoAction - do not allow delete of parent key if it has been imported
    - importedKeyCascade - delete rows that import a deleted key
    - importedKeySetNull - change imported key to `NULL` if its primary key has been deleted
    - importedKeyRestrict - same as importedKeyNoAction (for ODBC 2.x compatibility)
    - importedKeySetDefault - change imported key to default if its parent key has been deleted
12. FK_NAME String `=>` foreign key name (may be `null`)
13. PK_NAME String `=>` parent key name (may be `null`)
14. DEFERRABILITY short `=>` can the evaluation of foreign key constraints be deferred until commit
    - importedKeyInitiallyDeferred - see SQL92 for definition
    - importedKeyInitiallyImmediate - see SQL92 for definition
    - importedKeyNotDeferrable - see SQL92 for definition

Specified by:
  `getCrossReference` in interface `DatabaseMetaData`
Parameters:
  `parentCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `parentSchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
  `parentTable` - the name of the table that exports the key; pattern, or null (means any table) value
  `foreignCatalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `foreignSchema` - a schema name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means drop schema name from the selection criteria
  `foreignTable` - the name of the table that imports the key; pattern, or null (means any table) value is stored in the database
Returns:
  `ResultSet` - each row is a foreign key column description
Throws:
  `SQLException` - if a database access error occurs
See Also:
  - `getImportedKeys(java.lang.String, java.lang.String, java.lang.String)`

### getTypeInfo

public ResultSet getTypeInfo()
Retrieves a description of all the data types supported by this database. They are ordered by DATA_TYPE and then by how closely the data type maps to the corresponding JDBC SQL type.

If the database supports SQL distinct types, then getTypeInfo() will return a single row with a TYPE_NAME of DISTINCT and a DATA_TYPE of Types.DISTINCT. If the database supports SQL structured types, then getTypeInfo() will return a single row with a TYPE_NAME of STRUCT and a DATA_TYPE of Types.STRUCT.

If SQL distinct or structured types are supported, then information on the individual types may be obtained from the getUDTs() method.

Each type description has the following columns:

1. TYPE_NAME String `=>` Type name
2. DATA_TYPE int `=>` SQL data type from java.sql.Types
3. PRECISION int `=>` maximum precision
4. LITERAL_PREFIX String `=>` prefix used to quote a literal (may be `null` )
5. LITERAL_SUFFIX String `=>` suffix used to quote a literal (may be `null` )
6. CREATE_PARAMS String `=>` parameters used in creating the type (may be `null`)
7. NULLABLE short `=>` can you use NULL for this type.
   - typeNoNulls - does not allow NULL values
   - typeNullable - allows NULL values
   - typeNullableUnknown - nullability unknown
8. CASE_SENSITIVE boolean`=>` is it case sensitive.
9. SEARCHABLE short `=>` can you use "WHERE" based on this type:
   - typePredNone - No support
   - typePredChar - Only supported with WHERE .. LIKE
   - typePredBasic - Supported except for WHERE .. LIKE
   - typeSearchable - Supported for all WHERE ..
10. UNSIGNED_ATTRIBUTE boolean `=>` is it unsigned.
11. FIXED_PREC_SCALE boolean `=>` can it be a money value.
12. AUTO_INCREMENT boolean `=>` can it be used for an auto-increment value.
13. LOCAL_TYPE_NAME String `=>` localized version of type name (may be `null`)
14. MINIMUM_SCALE short `=>` minimum scale supported
15. MAXIMUM_SCALE short `=>` maximum scale supported
16. SQL_DATA_TYPE int `=>` unused
17. SQL_DATETIME_SUB int `=>` unused
18. NUM_PREC_RADIX int `=>` usually 2 or 10

The PRECISION column represents the maximum column size that the server supports for the given datatype. For numeric data, this is the maximum precision. For character data, this is the length in characters. For datetime datatypes, this is the length in characters of the String representation (assuming the maximum allowed precision of the fractional seconds component). For binary data, this is the length in bytes. For the ROWID datatype, this is the length in bytes. Null is returned for data types where the column size is not applicable.

Specified by:
  `getTypeInfo` in interface `DatabaseMetaData`
Returns:
  a `ResultSet` object in which each row is an SQL type description

### getIndexInfo

public ResultSet getIndexInfo(String catalog, String schema, String table, boolean unique, boolean approximate) throws SQLException
Retrieves a description of the given table's indices and statistics. They are ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.

Each index column description has the following columns:

1. TABLE_CAT String `=>` table catalog (may be `null`)
2. TABLE_SCHEM String `=>` table schema (may be `null`)
3. TABLE_NAME String `=>` table name
4. NON_UNIQUE boolean `=>` Can index values be non-unique. false when TYPE is tableIndexStatistic
5. INDEX_QUALIFIER String `=>` index catalog (may be `null`); `null` when TYPE is tableIndexStatistic
6. INDEX_NAME String `=>` index name; `null` when TYPE is tableIndexStatistic
7. TYPE short `=>` index type:
   - tableIndexStatistic - this identifies table statistics that are returned in conjuction with a table's index descriptions
   - tableIndexClustered - this is a clustered index
   - tableIndexHashed - this is a hashed index
   - tableIndexOther - this is some other style of index
8. ORDINAL_POSITION short `=>` column sequence number within index; zero when TYPE is tableIndexStatistic
9. COLUMN_NAME String `=>` column name; `null` when TYPE is tableIndexStatistic
10. ASC_OR_DESC String `=>` column sort sequence, "A" `=>` ascending, "D" `=>` descending, may be `null` if sort sequence is not supported; `null` when TYPE is tableIndexStatistic
11. CARDINALITY long `=>` When TYPE is tableIndexStatistic, then this is the number of rows in the table; otherwise, it is the number of unique values in the index.
12. PAGES long `=>` When TYPE is tableIndexStatisic then this is the number of pages used for the table, otherwise it is the number of pages used for the current index.
13. FILTER_CONDITION String `=>` Filter condition, if any. (may be `null` )

Specified by:
  `getIndexInfo` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in this database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schema` - a schema name; must match the schema name as it is stored in this database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `table` - a table name; must match the table name as it is stored in this database
  `unique` - when true, return only indices for unique values; when false, return indices regardless of whether unique or not
  `approximate` - when true, result is allowed to reflect approximate or out of data values; when false, results are requested to be accurate
Returns:
  `ResultSet` - each row is an index column description
Throws:
  `SQLException` - if a database access error occurs

### supportsResultSetType

public boolean supportsResultSetType(int type)
Retrieves whether this database supports the given result set type. ResultSet.TYPE_FORWARD_ONLY and ResultSet.TYPE_SCROLL_INSENSITIVE are supported.

Specified by:
  `supportsResultSetType` in interface `DatabaseMetaData`
Parameters:
  `type` - one of the following `ResultSet` constants:
  - `ResultSet.TYPE_FORWARD_ONLY`
  - `ResultSet.TYPE_SCROLL_INSENSITIVE`
  - `ResultSet.TYPE_SCROLL_SENSITIVE`
Returns:
  true if supported

### supportsResultSetConcurrency

public boolean supportsResultSetConcurrency(int type, int concurrency)
Retrieves whether this database supports the given concurrency type in combination with the given result set type. All are supported, but combination that use ResultSet.TYPE_SCROLL_INSENSITIVE.

Specified by:
  `supportsResultSetConcurrency` in interface `DatabaseMetaData`
Parameters:
  `type` - one of the following `ResultSet` constants:
  - `ResultSet.TYPE_FORWARD_ONLY`
  - `ResultSet.TYPE_SCROLL_INSENSITIVE`
  - `ResultSet.TYPE_SCROLL_SENSITIVE`
  `concurrency` - one of the following `ResultSet` constants:
  - `ResultSet.CONCUR_READ_ONLY`
  - `ResultSet.CONCUR_UPDATABLE`
Returns:
  true if supported

### ownUpdatesAreVisible

public boolean ownUpdatesAreVisible(int type)

Specified by:
  `ownUpdatesAreVisible` in interface `DatabaseMetaData`

### ownDeletesAreVisible

public boolean ownDeletesAreVisible(int type)

Specified by:
  `ownDeletesAreVisible` in interface `DatabaseMetaData`

### ownInsertsAreVisible

public boolean ownInsertsAreVisible(int type)

Specified by:
  `ownInsertsAreVisible` in interface `DatabaseMetaData`

### othersUpdatesAreVisible

public boolean othersUpdatesAreVisible(int type)

Specified by:
  `othersUpdatesAreVisible` in interface `DatabaseMetaData`

### othersDeletesAreVisible

public boolean othersDeletesAreVisible(int type)

Specified by:
  `othersDeletesAreVisible` in interface `DatabaseMetaData`

### othersInsertsAreVisible

public boolean othersInsertsAreVisible(int type)

Specified by:
  `othersInsertsAreVisible` in interface `DatabaseMetaData`

### updatesAreDetected

public boolean updatesAreDetected(int type)

Specified by:
  `updatesAreDetected` in interface `DatabaseMetaData`

### deletesAreDetected

public boolean deletesAreDetected(int type)

Specified by:
  `deletesAreDetected` in interface `DatabaseMetaData`

### insertsAreDetected

public boolean insertsAreDetected(int type)

Specified by:
  `insertsAreDetected` in interface `DatabaseMetaData`

### supportsBatchUpdates

public boolean supportsBatchUpdates()

Specified by:
  `supportsBatchUpdates` in interface `DatabaseMetaData`

### getUDTs

public ResultSet getUDTs(String catalog, String schemaPattern, String typeNamePattern, int[] types) throws SQLException
Retrieves a description of the user-defined types (UDTs) defined in a particular schema. Schema-specific UDTs may have type `JAVA_OBJECT`, `STRUCT`, or `DISTINCT`.

Only types matching the catalog, schema, type name and type criteria are returned. They are ordered by `DATA_TYPE`, `TYPE_CAT`, `TYPE_SCHEM` and `TYPE_NAME`. The type name parameter may be a fully-qualified name. In this case, the catalog and schemaPattern parameters are ignored.

Each type description has the following columns:

1. TYPE_CAT String `=>` the type's catalog (may be `null`)
2. TYPE_SCHEM String `=>` type's schema (may be `null`)
3. TYPE_NAME String `=>` type name
4. CLASS_NAME String `=>` Java class name
5. DATA_TYPE int `=>` type value defined in java.sql.Types. One of JAVA_OBJECT, STRUCT, or DISTINCT
6. REMARKS String `=>` explanatory comment on the type
7. BASE_TYPE short `=>` type code of the source type of a DISTINCT type or the type that implements the user-generated reference type of the SELF_REFERENCING_COLUMN of a structured type as defined in java.sql.Types (`null` if DATA_TYPE is not DISTINCT or not STRUCT with REFERENCE_GENERATION = USER_DEFINED)

Note: If the driver does not support UDTs, an empty result set is returned.

Specified by:
  `getUDTs` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema pattern name; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database; may be a fully qualified name
  `types` - a list of user-defined types (JAVA_OBJECT, STRUCT, or DISTINCT) to include; `null` returns all types
Returns:
  `ResultSet` object in which each row describes a UDT
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.2
See Also:
  - `getSearchStringEscape()`

### getConnection

public Connection getConnection()

Specified by:
  `getConnection` in interface `DatabaseMetaData`

### supportsSavepoints

public boolean supportsSavepoints()

Specified by:
  `supportsSavepoints` in interface `DatabaseMetaData`

### supportsNamedParameters

public boolean supportsNamedParameters()

Specified by:
  `supportsNamedParameters` in interface `DatabaseMetaData`

### supportsMultipleOpenResults

public boolean supportsMultipleOpenResults()

Specified by:
  `supportsMultipleOpenResults` in interface `DatabaseMetaData`

### supportsGetGeneratedKeys

public boolean supportsGetGeneratedKeys()

Specified by:
  `supportsGetGeneratedKeys` in interface `DatabaseMetaData`

### getSuperTypes

public ResultSet getSuperTypes(String catalog, String schemaPattern, String typeNamePattern) throws SQLException
Retrieves a description of the user-defined type (UDT) hierarchies defined in a particular schema in this database. Only the immediate super type/ subtype relationship is modeled. Only supertype information for UDTs matching the catalog, schema, and type name is returned. The type name parameter may be a fully-qualified name. When the UDT name supplied is a fully-qualified name, the catalog and schemaPattern parameters are ignored. If a UDT does not have a direct super type, it is not listed here. A row of the `ResultSet` object returned by this method describes the designated UDT and a direct supertype. A row has the following columns:

1. TYPE_CAT String `=>` the UDT's catalog (may be `null`)
2. TYPE_SCHEM String `=>` UDT's schema (may be `null`)
3. TYPE_NAME String `=>` type name of the UDT
4. SUPERTYPE_CAT String `=>` the direct super type's catalog (may be `null` )
5. SUPERTYPE_SCHEM String `=>` the direct super type's schema (may be `null`)
6. SUPERTYPE_NAME String `=>` the direct super type's name

Note: If the driver does not support type hierarchies, an empty result set is returned.

Specified by:
  `getSuperTypes` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `typeNamePattern` - a UDT name pattern; may be a fully-qualified name
Returns:
  a `ResultSet` object in which a row gives information about the designated UDT
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.4
See Also:
  - `getSearchStringEscape()`

### getSuperTables

public ResultSet getSuperTables(String catalog, String schemaPattern, String tableNamePattern) throws SQLException
Retrieves a description of the table hierarchies defined in a particular schema in this database.

Only supertable information for tables matching the catalog, schema and table name are returned. The table name parameter may be a fully-qualified name, in which case, the catalog and schemaPattern parameters are ignored. If a table does not have a super table, it is not listed here. Supertables have to be defined in the same catalog and schema as the sub tables. Therefore, the type description does not need to include this information for the supertable.

Each type description has the following columns:

1. TABLE_CAT String `=>` the type's catalog (may be `null`)
2. TABLE_SCHEM String `=>` type's schema (may be `null`)
3. TABLE_NAME String `=>` type name
4. SUPERTABLE_NAME String `=>` the direct super type's name

Note: If the driver does not support type hierarchies, an empty result set is returned.

Specified by:
  `getSuperTables` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; "" retrieves those without a catalog; `null` means drop catalog name from the selection criteria
  `schemaPattern` - a schema name pattern; "" retrieves those without a schema
  `tableNamePattern` - a table name pattern; may be a fully-qualified name
Returns:
  a `ResultSet` object in which each row is a type description
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.4
See Also:
  - `getSearchStringEscape()`

### getAttributes

public ResultSet getAttributes(String catalog, String schemaPattern, String typeNamePattern, String attributeNamePattern) throws SQLException
Retrieves a description of the given attribute of the given type for a user-defined type (UDT) that is available in the given schema and catalog. Descriptions are returned only for attributes of UDTs matching the catalog, schema, type, and attribute name criteria. They are ordered by `TYPE_CAT`, `TYPE_SCHEM`, `TYPE_NAME` and `ORDINAL_POSITION`. This description does not contain inherited attributes. The `ResultSet` object that is returned has the following columns:

1. TYPE_CAT String `=>` type catalog (may be `null`)
2. TYPE_SCHEM String `=>` type schema (may be `null`)
3. TYPE_NAME String `=>` type name
4. ATTR_NAME String `=>` attribute name
5. DATA_TYPE int `=>` attribute type SQL type from java.sql.Types
6. ATTR_TYPE_NAME String `=>` Data source dependent type name. For a UDT, the type name is fully qualified. For a REF, the type name is fully qualified and represents the target type of the reference type.
7. ATTR_SIZE int `=>` column size. For char or date types this is the maximum number of characters; for numeric or decimal types this is precision.
8. DECIMAL_DIGITS int `=>` the number of fractional digits. Null is returned for data types where DECIMAL_DIGITS is not applicable.
9. NUM_PREC_RADIX int `=>` Radix (typically either 10 or 2)
10. NULLABLE int `=>` whether NULL is allowed
    - attributeNoNulls - might not allow NULL values
    - attributeNullable - definitely allows NULL values
    - attributeNullableUnknown - nullability unknown
11. REMARKS String `=>` comment describing column (may be `null`)
12. ATTR_DEF String `=>` default value (may be`null`)
13. SQL_DATA_TYPE int `=>` unused
14. SQL_DATETIME_SUB int `=>` unused
15. CHAR_OCTET_LENGTH int `=>` for char types the maximum number of bytes in the column
16. ORDINAL_POSITION int `=>` index of the attribute in the UDT (starting at 1)
17. IS_NULLABLE String `=>` ISO rules are used to determine the nullability for a attribute.
    - YES --- if the attribute can include NULLs
    - NO --- if the attribute cannot include NULLs
    - empty string --- if the nullability for the attribute is unknown
18. SCOPE_CATALOG String `=>` catalog of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
19. SCOPE_SCHEMA String `=>` schema of table that is the scope of a reference attribute (`null` if DATA_TYPE isn't REF)
20. SCOPE_TABLE String `=>` table name that is the scope of a reference attribute (`null` if the DATA_TYPE isn't REF)
21. SOURCE_DATA_TYPE short `=>` source type of a distinct type or user-generated Ref type,SQL type from java.sql.Types (`null` if DATA_TYPE isn't DISTINCT or user-generated REF)

Specified by:
  `getAttributes` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `typeNamePattern` - a type name pattern; must match the type name as it is stored in the database
  `attributeNamePattern` - an attribute name pattern; must match the attribute name as it is declared in the database
Returns:
  a `ResultSet` object in which each row is an attribute description
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.4
See Also:
  - `getSearchStringEscape()`

### supportsResultSetHoldability

public boolean supportsResultSetHoldability(int holdability)

Specified by:
  `supportsResultSetHoldability` in interface `DatabaseMetaData`

### getResultSetHoldability

public int getResultSetHoldability()

Specified by:
  `getResultSetHoldability` in interface `DatabaseMetaData`

### getDatabaseMajorVersion

public int getDatabaseMajorVersion()

Specified by:
  `getDatabaseMajorVersion` in interface `DatabaseMetaData`

### getDatabaseMinorVersion

public int getDatabaseMinorVersion()

Specified by:
  `getDatabaseMinorVersion` in interface `DatabaseMetaData`

### getJDBCMajorVersion

public int getJDBCMajorVersion()

Specified by:
  `getJDBCMajorVersion` in interface `DatabaseMetaData`

### getJDBCMinorVersion

public int getJDBCMinorVersion()

Specified by:
  `getJDBCMinorVersion` in interface `DatabaseMetaData`

### getSQLStateType

public int getSQLStateType()

Specified by:
  `getSQLStateType` in interface `DatabaseMetaData`

### locatorsUpdateCopy

public boolean locatorsUpdateCopy()

Specified by:
  `locatorsUpdateCopy` in interface `DatabaseMetaData`

### supportsStatementPooling

public boolean supportsStatementPooling()

Specified by:
  `supportsStatementPooling` in interface `DatabaseMetaData`

### getRowIdLifetime

public RowIdLifetime getRowIdLifetime()

Specified by:
  `getRowIdLifetime` in interface `DatabaseMetaData`

### supportsStoredFunctionsUsingCallSyntax

public boolean supportsStoredFunctionsUsingCallSyntax()

Specified by:
  `supportsStoredFunctionsUsingCallSyntax` in interface `DatabaseMetaData`

### autoCommitFailureClosesAllResultSets

public boolean autoCommitFailureClosesAllResultSets()

Specified by:
  `autoCommitFailureClosesAllResultSets` in interface `DatabaseMetaData`

### getClientInfoProperties

public ResultSet getClientInfoProperties()
Retrieves a list of the client info properties that the driver supports. The result set contains the following columns

1. NAME String : The name of the client info property
2. MAX_LEN int : The maximum length of the value for the property
3. DEFAULT_VALUE String : The default value of the property
4. DESCRIPTION String : A description of the property. This will typically contain information as to where this property is stored in the database.

The ResultSet is sorted by the NAME column

Specified by:
  `getClientInfoProperties` in interface `DatabaseMetaData`
Returns:
  A ResultSet object; each row is a supported client info property

### getFunctions

public ResultSet getFunctions(String catalog, String schemaPattern, String functionNamePattern) throws SQLException
Retrieves a description of the system and user functions available in the given catalog. Only system and user function descriptions matching the schema and function name criteria are returned. They are ordered by `FUNCTION_CAT`, `FUNCTION_SCHEM`, `FUNCTION_NAME` and `SPECIFIC_ NAME`.

Each function description has the following columns:

1. FUNCTION_CAT String `=>` function catalog (may be `null`)
2. FUNCTION_SCHEM String `=>` function schema (may be `null`)
3. FUNCTION_NAME String `=>` function name. This is the name used to invoke the function
4. REMARKS String `=>` explanatory comment on the function
5. FUNCTION_TYPE short `=>` kind of function:
   - functionResultUnknown - Cannot determine if a return value or table will be returned
   - functionNoTable- Does not return a table
   - functionReturnsTable - Returns a table
6. SPECIFIC_NAME String `=>` the name which uniquely identifies this function within its schema. This is a user specified, or DBMS generated, name that may be different then the `FUNCTION_NAME` for example with overload functions

A user may not have permission to execute any of the functions that are returned by `getFunctions`

Specified by:
  `getFunctions` in interface `DatabaseMetaData`
Parameters:
  `catalog` - a catalog name; must match the catalog name as it is stored in the database; "" retrieves those without a catalog; `null` means that the catalog name should not be used to narrow the search
  `schemaPattern` - a schema name pattern; must match the schema name as it is stored in the database; "" retrieves those without a schema; `null` means that the schema name should not be used to narrow the search
  `functionNamePattern` - a function name pattern; must match the function name as it is stored in the database
Returns:
  `ResultSet` - each row is a function description
Throws:
  `SQLException` - if a database access error occurs
Since:
  1.6
See Also:
  - `getSearchStringEscape()`

### unwrap

public <T> T unwrap(Class<T> iface) throws SQLException

Specified by:
  `unwrap` in interface `Wrapper`
Throws:
  `SQLException`

### isWrapperFor

public boolean isWrapperFor(Class<?> iface)

Specified by:
  `isWrapperFor` in interface `Wrapper`

### getMaxLogicalLobSize

public long getMaxLogicalLobSize()

Specified by:
  `getMaxLogicalLobSize` in interface `DatabaseMetaData`